package b4a.example;


import anywheresoftware.b4a.B4AMenuItem;
import android.app.Activity;
import android.os.Bundle;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.B4AActivity;
import anywheresoftware.b4a.ObjectWrapper;
import anywheresoftware.b4a.objects.ActivityWrapper;
import java.lang.reflect.InvocationTargetException;
import anywheresoftware.b4a.B4AUncaughtException;
import anywheresoftware.b4a.debug.*;
import java.lang.ref.WeakReference;

public class main extends Activity implements B4AActivity{
	public static main mostCurrent;
	static boolean afterFirstLayout;
	static boolean isFirst = true;
    private static boolean processGlobalsRun = false;
	BALayout layout;
	public static BA processBA;
	BA activityBA;
    ActivityWrapper _activity;
    java.util.ArrayList<B4AMenuItem> menuItems;
	public static final boolean fullScreen = false;
	public static final boolean includeTitle = true;
    public static WeakReference<Activity> previousOne;

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		if (isFirst) {
			processBA = new BA(this.getApplicationContext(), null, null, "b4a.example", "b4a.example.main");
			processBA.loadHtSubs(this.getClass());
	        float deviceScale = getApplicationContext().getResources().getDisplayMetrics().density;
	        BALayout.setDeviceScale(deviceScale);
            
		}
		else if (previousOne != null) {
			Activity p = previousOne.get();
			if (p != null && p != this) {
                BA.LogInfo("Killing previous instance (main).");
				p.finish();
			}
		}
        processBA.runHook("oncreate", this, null);
		if (!includeTitle) {
        	this.getWindow().requestFeature(android.view.Window.FEATURE_NO_TITLE);
        }
        if (fullScreen) {
        	getWindow().setFlags(android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN,   
        			android.view.WindowManager.LayoutParams.FLAG_FULLSCREEN);
        }
		mostCurrent = this;
        processBA.sharedProcessBA.activityBA = null;
		layout = new BALayout(this);
		setContentView(layout);
		afterFirstLayout = false;
		BA.handler.postDelayed(new WaitForLayout(), 5);

	}
	private static class WaitForLayout implements Runnable {
		public void run() {
			if (afterFirstLayout)
				return;
			if (mostCurrent == null)
				return;
            
			if (mostCurrent.layout.getWidth() == 0) {
				BA.handler.postDelayed(this, 5);
				return;
			}
			mostCurrent.layout.getLayoutParams().height = mostCurrent.layout.getHeight();
			mostCurrent.layout.getLayoutParams().width = mostCurrent.layout.getWidth();
			afterFirstLayout = true;
			mostCurrent.afterFirstLayout();
		}
	}
	private void afterFirstLayout() {
        if (this != mostCurrent)
			return;
		activityBA = new BA(this, layout, processBA, "b4a.example", "b4a.example.main");
        
        processBA.sharedProcessBA.activityBA = new java.lang.ref.WeakReference<BA>(activityBA);
        anywheresoftware.b4a.objects.ViewWrapper.lastId = 0;
        _activity = new ActivityWrapper(activityBA, "activity");
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (BA.isShellModeRuntimeCheck(processBA)) {
			if (isFirst)
				processBA.raiseEvent2(null, true, "SHELL", false);
			processBA.raiseEvent2(null, true, "CREATE", true, "b4a.example.main", processBA, activityBA, _activity, anywheresoftware.b4a.keywords.Common.Density, mostCurrent);
			_activity.reinitializeForShell(activityBA, "activity");
		}
        initializeProcessGlobals();		
        initializeGlobals();
        
        BA.LogInfo("** Activity (main) Create, isFirst = " + isFirst + " **");
        processBA.raiseEvent2(null, true, "activity_create", false, isFirst);
		isFirst = false;
		if (this != mostCurrent)
			return;
        processBA.setActivityPaused(false);
        BA.LogInfo("** Activity (main) Resume **");
        processBA.raiseEvent(null, "activity_resume");
        if (android.os.Build.VERSION.SDK_INT >= 11) {
			try {
				android.app.Activity.class.getMethod("invalidateOptionsMenu").invoke(this,(Object[]) null);
			} catch (Exception e) {
				e.printStackTrace();
			}
		}

	}
	public void addMenuItem(B4AMenuItem item) {
		if (menuItems == null)
			menuItems = new java.util.ArrayList<B4AMenuItem>();
		menuItems.add(item);
	}
	@Override
	public boolean onCreateOptionsMenu(android.view.Menu menu) {
		super.onCreateOptionsMenu(menu);
        try {
            if (processBA.subExists("activity_actionbarhomeclick")) {
                Class.forName("android.app.ActionBar").getMethod("setHomeButtonEnabled", boolean.class).invoke(
                    getClass().getMethod("getActionBar").invoke(this), true);
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        if (processBA.runHook("oncreateoptionsmenu", this, new Object[] {menu}))
            return true;
		if (menuItems == null)
			return false;
		for (B4AMenuItem bmi : menuItems) {
			android.view.MenuItem mi = menu.add(bmi.title);
			if (bmi.drawable != null)
				mi.setIcon(bmi.drawable);
            if (android.os.Build.VERSION.SDK_INT >= 11) {
				try {
                    if (bmi.addToBar) {
				        android.view.MenuItem.class.getMethod("setShowAsAction", int.class).invoke(mi, 1);
                    }
				} catch (Exception e) {
					e.printStackTrace();
				}
			}
			mi.setOnMenuItemClickListener(new B4AMenuItemsClickListener(bmi.eventName.toLowerCase(BA.cul)));
		}
        
		return true;
	}   
 @Override
 public boolean onOptionsItemSelected(android.view.MenuItem item) {
    if (item.getItemId() == 16908332) {
        processBA.raiseEvent(null, "activity_actionbarhomeclick");
        return true;
    }
    else
        return super.onOptionsItemSelected(item); 
}
@Override
 public boolean onPrepareOptionsMenu(android.view.Menu menu) {
    super.onPrepareOptionsMenu(menu);
    processBA.runHook("onprepareoptionsmenu", this, new Object[] {menu});
    return true;
    
 }
 protected void onStart() {
    super.onStart();
    processBA.runHook("onstart", this, null);
}
 protected void onStop() {
    super.onStop();
    processBA.runHook("onstop", this, null);
}
    public void onWindowFocusChanged(boolean hasFocus) {
       super.onWindowFocusChanged(hasFocus);
       if (processBA.subExists("activity_windowfocuschanged"))
           processBA.raiseEvent2(null, true, "activity_windowfocuschanged", false, hasFocus);
    }
	private class B4AMenuItemsClickListener implements android.view.MenuItem.OnMenuItemClickListener {
		private final String eventName;
		public B4AMenuItemsClickListener(String eventName) {
			this.eventName = eventName;
		}
		public boolean onMenuItemClick(android.view.MenuItem item) {
			processBA.raiseEvent(item.getTitle(), eventName + "_click");
			return true;
		}
	}
    public static Class<?> getObject() {
		return main.class;
	}
    private Boolean onKeySubExist = null;
    private Boolean onKeyUpSubExist = null;
	@Override
	public boolean onKeyDown(int keyCode, android.view.KeyEvent event) {
		if (onKeySubExist == null)
			onKeySubExist = processBA.subExists("activity_keypress");
		if (onKeySubExist) {
			if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK &&
					android.os.Build.VERSION.SDK_INT >= 18) {
				HandleKeyDelayed hk = new HandleKeyDelayed();
				hk.kc = keyCode;
				BA.handler.post(hk);
				return true;
			}
			else {
				boolean res = new HandleKeyDelayed().runDirectly(keyCode);
				if (res)
					return true;
			}
		}
		return super.onKeyDown(keyCode, event);
	}
	private class HandleKeyDelayed implements Runnable {
		int kc;
		public void run() {
			runDirectly(kc);
		}
		public boolean runDirectly(int keyCode) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keypress", false, keyCode);
			if (res == null || res == true) {
                return true;
            }
            else if (keyCode == anywheresoftware.b4a.keywords.constants.KeyCodes.KEYCODE_BACK) {
				finish();
				return true;
			}
            return false;
		}
		
	}
    @Override
	public boolean onKeyUp(int keyCode, android.view.KeyEvent event) {
		if (onKeyUpSubExist == null)
			onKeyUpSubExist = processBA.subExists("activity_keyup");
		if (onKeyUpSubExist) {
			Boolean res =  (Boolean)processBA.raiseEvent2(_activity, false, "activity_keyup", false, keyCode);
			if (res == null || res == true)
				return true;
		}
		return super.onKeyUp(keyCode, event);
	}
	@Override
	public void onNewIntent(android.content.Intent intent) {
        super.onNewIntent(intent);
		this.setIntent(intent);
        processBA.runHook("onnewintent", this, new Object[] {intent});
	}
    @Override 
	public void onPause() {
		super.onPause();
        if (_activity == null) //workaround for emulator bug (Issue 2423)
            return;
		anywheresoftware.b4a.Msgbox.dismiss(true);
        BA.LogInfo("** Activity (main) Pause, UserClosed = " + activityBA.activity.isFinishing() + " **");
        processBA.raiseEvent2(_activity, true, "activity_pause", false, activityBA.activity.isFinishing());		
        processBA.setActivityPaused(true);
        mostCurrent = null;
        if (!activityBA.activity.isFinishing())
			previousOne = new WeakReference<Activity>(this);
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        processBA.runHook("onpause", this, null);
	}

	@Override
	public void onDestroy() {
        super.onDestroy();
		previousOne = null;
        processBA.runHook("ondestroy", this, null);
	}
    @Override 
	public void onResume() {
		super.onResume();
        mostCurrent = this;
        anywheresoftware.b4a.Msgbox.isDismissing = false;
        if (activityBA != null) { //will be null during activity create (which waits for AfterLayout).
        	ResumeMessage rm = new ResumeMessage(mostCurrent);
        	BA.handler.post(rm);
        }
        processBA.runHook("onresume", this, null);
	}
    private static class ResumeMessage implements Runnable {
    	private final WeakReference<Activity> activity;
    	public ResumeMessage(Activity activity) {
    		this.activity = new WeakReference<Activity>(activity);
    	}
		public void run() {
			if (mostCurrent == null || mostCurrent != activity.get())
				return;
			processBA.setActivityPaused(false);
            BA.LogInfo("** Activity (main) Resume **");
		    processBA.raiseEvent(mostCurrent._activity, "activity_resume", (Object[])null);
		}
    }
	@Override
	protected void onActivityResult(int requestCode, int resultCode,
	      android.content.Intent data) {
		processBA.onActivityResult(requestCode, resultCode, data);
        processBA.runHook("onactivityresult", this, new Object[] {requestCode, resultCode});
	}
	private static void initializeGlobals() {
		processBA.raiseEvent2(null, true, "globals", false, (Object[])null);
	}

public anywheresoftware.b4a.keywords.Common __c = null;
public static anywheresoftware.b4a.objects.BleManager _manager = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _readcharacteristic = null;
public static anywheresoftware.b4a.objects.BleManager.GattCharacteristic _writecharacteristic = null;
public static anywheresoftware.b4a.objects.BleManager.GattServiceWrapper _bleservice = null;
public anywheresoftware.b4a.objects.collections.List _listbledevicesname = null;
public anywheresoftware.b4a.objects.collections.List _listbledevicesmacadress = null;
public static int _connectstate = 0;
public static int _cstatedisconnect = 0;
public static int _cstatepreconnect = 0;
public static int _cstateconnect = 0;
public anywheresoftware.b4a.objects.LabelWrapper _rx = null;
public anywheresoftware.b4a.objects.ButtonWrapper _tx = null;

public static boolean isAnyActivityVisible() {
    boolean vis = false;
vis = vis | (main.mostCurrent != null);
return vis;}
public static String  _activity_create(boolean _firsttime) throws Exception{
 //BA.debugLineNum = 33;BA.debugLine="Sub Activity_Create(FirstTime As Boolean)";
 //BA.debugLineNum = 34;BA.debugLine="Activity.LoadLayout(\"Layout1\")";
mostCurrent._activity.LoadLayout("Layout1",mostCurrent.activityBA);
 //BA.debugLineNum = 35;BA.debugLine="Try";
try { //BA.debugLineNum = 36;BA.debugLine="Manager.Initialize(\"BLE\")";
_manager.Initialize(processBA,"BLE");
 } 
       catch (Exception e21) {
			processBA.setLastException(e21); //BA.debugLineNum = 38;BA.debugLine="Log(\"Error create service : \" & LastException.Me";
anywheresoftware.b4a.keywords.Common.Log("Error create service : "+anywheresoftware.b4a.keywords.Common.LastException(mostCurrent.activityBA).getMessage());
 };
 //BA.debugLineNum = 40;BA.debugLine="listBLEDevicesName.Initialize";
mostCurrent._listbledevicesname.Initialize();
 //BA.debugLineNum = 41;BA.debugLine="listBLEDevicesMacAdress.Initialize";
mostCurrent._listbledevicesmacadress.Initialize();
 //BA.debugLineNum = 42;BA.debugLine="Activity.AddMenuItem(\"Connect\", \"connectBT\")";
mostCurrent._activity.AddMenuItem("Connect","connectBT");
 //BA.debugLineNum = 43;BA.debugLine="End Sub";
return "";
}
public static String  _activity_pause(boolean _userclosed) throws Exception{
 //BA.debugLineNum = 49;BA.debugLine="Sub Activity_Pause (UserClosed As Boolean)";
 //BA.debugLineNum = 51;BA.debugLine="End Sub";
return "";
}
public static String  _activity_resume() throws Exception{
 //BA.debugLineNum = 45;BA.debugLine="Sub Activity_Resume";
 //BA.debugLineNum = 47;BA.debugLine="End Sub";
return "";
}
public static String  _ble_characteristicchanged(anywheresoftware.b4a.objects.BleManager.GattCharacteristic _characteristic) throws Exception{
 //BA.debugLineNum = 109;BA.debugLine="Sub ble_CharacteristicChanged (Characteristic As B";
 //BA.debugLineNum = 110;BA.debugLine="Log(\"Read -> \" & Characteristic.GetStringValue(0)";
anywheresoftware.b4a.keywords.Common.Log("Read -> "+_characteristic.GetStringValue((int) (0)));
 //BA.debugLineNum = 111;BA.debugLine="RX.Text = RX.Text & Characteristic.GetStringValue";
mostCurrent._rx.setText((Object)(mostCurrent._rx.getText()+_characteristic.GetStringValue((int) (0))));
 //BA.debugLineNum = 112;BA.debugLine="End Sub";
return "";
}
public static String  _ble_connected(anywheresoftware.b4a.objects.collections.Map _services) throws Exception{
 //BA.debugLineNum = 90;BA.debugLine="Sub ble_Connected (Services As Map)";
 //BA.debugLineNum = 91;BA.debugLine="If ConnectState = cstatePreConnect Then";
if (_connectstate==_cstatepreconnect) { 
 //BA.debugLineNum = 92;BA.debugLine="ConnectState = cstateConnect";
_connectstate = _cstateconnect;
 //BA.debugLineNum = 93;BA.debugLine="Log(\"Connected\")";
anywheresoftware.b4a.keywords.Common.Log("Connected");
 //BA.debugLineNum = 94;BA.debugLine="bleService = Services.GetValueAt(2)";
_bleservice.setObject((android.bluetooth.BluetoothGattService)(_services.GetValueAt((int) (2))));
 //BA.debugLineNum = 95;BA.debugLine="readCharacteristic = bleService.GetCharacteri";
_readcharacteristic.setObject((android.bluetooth.BluetoothGattCharacteristic)(_bleservice.GetCharacteristics().GetValueAt((int) (0))));
 //BA.debugLineNum = 96;BA.debugLine="Manager.ReadCharacteristic(readCharacteristic";
_manager.ReadCharacteristic(_readcharacteristic);
 //BA.debugLineNum = 97;BA.debugLine="Manager.SetCharacteristicNotification(readCha";
_manager.SetCharacteristicNotification(_readcharacteristic,anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 98;BA.debugLine="writeCharacteristic = bleService.GetCharacter";
_writecharacteristic.setObject((android.bluetooth.BluetoothGattCharacteristic)(_bleservice.GetCharacteristics().GetValueAt((int) (0))));
 };
 //BA.debugLineNum = 100;BA.debugLine="End Sub";
return "";
}
public static String  _ble_devicefound(String _name,String _macaddress) throws Exception{
 //BA.debugLineNum = 68;BA.debugLine="Sub ble_DeviceFound (Name As String, MacAddress As";
 //BA.debugLineNum = 69;BA.debugLine="Log(Name & \", \" & MacAddress)";
anywheresoftware.b4a.keywords.Common.Log(_name+", "+_macaddress);
 //BA.debugLineNum = 70;BA.debugLine="listBLEDevicesName.Add(Name)";
mostCurrent._listbledevicesname.Add((Object)(_name));
 //BA.debugLineNum = 71;BA.debugLine="listBLEDevicesMacAdress.Add(MacAddress)";
mostCurrent._listbledevicesmacadress.Add((Object)(_macaddress));
 //BA.debugLineNum = 72;BA.debugLine="End Sub";
return "";
}
public static String  _ble_disconnected() throws Exception{
 //BA.debugLineNum = 102;BA.debugLine="Sub ble_Disconnected";
 //BA.debugLineNum = 103;BA.debugLine="ConnectState = cstateDisconnect";
_connectstate = _cstatedisconnect;
 //BA.debugLineNum = 104;BA.debugLine="Manager.refreshDeviceCache";
_manager.refreshDeviceCache();
 //BA.debugLineNum = 105;BA.debugLine="Manager.Close";
_manager.Close();
 //BA.debugLineNum = 106;BA.debugLine="Log(\"Disconnected\")";
anywheresoftware.b4a.keywords.Common.Log("Disconnected");
 //BA.debugLineNum = 107;BA.debugLine="End Sub";
return "";
}
public static String  _ble_discoveryfinished() throws Exception{
int _res = 0;
 //BA.debugLineNum = 74;BA.debugLine="Sub ble_DiscoveryFinished";
 //BA.debugLineNum = 75;BA.debugLine="Log(\"Search finished\")";
anywheresoftware.b4a.keywords.Common.Log("Search finished");
 //BA.debugLineNum = 76;BA.debugLine="If listBLEDevicesName.Size <> 0 Then";
if (mostCurrent._listbledevicesname.getSize()!=0) { 
 //BA.debugLineNum = 77;BA.debugLine="Dim res As Int";
_res = 0;
 //BA.debugLineNum = 78;BA.debugLine="res = InputList(listBLEDevicesName, \"Choose devi";
_res = anywheresoftware.b4a.keywords.Common.InputList(mostCurrent._listbledevicesname,"Choose device",(int) (-1),mostCurrent.activityBA);
 //BA.debugLineNum = 79;BA.debugLine="If res <> DialogResponse.CANCEL Then";
if (_res!=anywheresoftware.b4a.keywords.Common.DialogResponse.CANCEL) { 
 //BA.debugLineNum = 80;BA.debugLine="If ConnectState = cstateDisconnect Then";
if (_connectstate==_cstatedisconnect) { 
 //BA.debugLineNum = 81;BA.debugLine="ConnectState = cstatePreConnect";
_connectstate = _cstatepreconnect;
 //BA.debugLineNum = 82;BA.debugLine="Manager.Connect(listBLEDevicesMacAdress.Get(re";
_manager.Connect(BA.ObjectToString(mostCurrent._listbledevicesmacadress.Get(_res)),anywheresoftware.b4a.keywords.Common.True);
 };
 };
 }else {
 //BA.debugLineNum = 86;BA.debugLine="Msgbox2(\"Check Bluetooth and device is turned on";
anywheresoftware.b4a.keywords.Common.Msgbox2("Check Bluetooth and device is turned on and try again.","Connection error","OK","","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"error.png").getObject()),mostCurrent.activityBA);
 };
 //BA.debugLineNum = 88;BA.debugLine="End Sub";
return "";
}
public static String  _connectbt_click() throws Exception{
 //BA.debugLineNum = 53;BA.debugLine="Sub connectBT_Click";
 //BA.debugLineNum = 54;BA.debugLine="Log(\"Searching devices...\")";
anywheresoftware.b4a.keywords.Common.Log("Searching devices...");
 //BA.debugLineNum = 55;BA.debugLine="Manager.StopRssiTracking";
_manager.StopRssiTracking();
 //BA.debugLineNum = 56;BA.debugLine="Manager.Disconnect";
_manager.Disconnect();
 //BA.debugLineNum = 57;BA.debugLine="ConnectState = cstateDisconnect";
_connectstate = _cstatedisconnect;
 //BA.debugLineNum = 58;BA.debugLine="If (Manager.BleSupported) Then";
if ((_manager.getBleSupported())) { 
 //BA.debugLineNum = 59;BA.debugLine="Manager.Scan(3000, Null)";
_manager.Scan(processBA,(long) (3000),(String[])(anywheresoftware.b4a.keywords.Common.Null));
 }else {
 //BA.debugLineNum = 61;BA.debugLine="Msgbox2(\"Bluetooth 4 (BLE) not found !\", \"Error\"";
anywheresoftware.b4a.keywords.Common.Msgbox2("Bluetooth 4 (BLE) not found !","Error","OK","","",(android.graphics.Bitmap)(anywheresoftware.b4a.keywords.Common.LoadBitmap(anywheresoftware.b4a.keywords.Common.File.getDirAssets(),"error.png").getObject()),mostCurrent.activityBA);
 };
 //BA.debugLineNum = 63;BA.debugLine="listBLEDevicesName.clear";
mostCurrent._listbledevicesname.Clear();
 //BA.debugLineNum = 64;BA.debugLine="listBLEDevicesMacAdress.clear";
mostCurrent._listbledevicesmacadress.Clear();
 //BA.debugLineNum = 65;BA.debugLine="ToastMessageShow( \"Searching devices...\" ,True)";
anywheresoftware.b4a.keywords.Common.ToastMessageShow("Searching devices...",anywheresoftware.b4a.keywords.Common.True);
 //BA.debugLineNum = 66;BA.debugLine="End Sub";
return "";
}
public static String  _globals() throws Exception{
 //BA.debugLineNum = 22;BA.debugLine="Sub Globals";
 //BA.debugLineNum = 23;BA.debugLine="Dim listBLEDevicesName As List";
mostCurrent._listbledevicesname = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 24;BA.debugLine="Dim listBLEDevicesMacAdress As List";
mostCurrent._listbledevicesmacadress = new anywheresoftware.b4a.objects.collections.List();
 //BA.debugLineNum = 25;BA.debugLine="Dim ConnectState As Int";
_connectstate = 0;
 //BA.debugLineNum = 26;BA.debugLine="Dim cstateDisconnect As Int = 0";
_cstatedisconnect = (int) (0);
 //BA.debugLineNum = 27;BA.debugLine="Dim cstatePreConnect As Int = 1";
_cstatepreconnect = (int) (1);
 //BA.debugLineNum = 28;BA.debugLine="Dim cstateConnect As Int = 2";
_cstateconnect = (int) (2);
 //BA.debugLineNum = 29;BA.debugLine="Private RX As Label";
mostCurrent._rx = new anywheresoftware.b4a.objects.LabelWrapper();
 //BA.debugLineNum = 30;BA.debugLine="Private TX As Button";
mostCurrent._tx = new anywheresoftware.b4a.objects.ButtonWrapper();
 //BA.debugLineNum = 31;BA.debugLine="End Sub";
return "";
}

public static void initializeProcessGlobals() {
    
    if (main.processGlobalsRun == false) {
	    main.processGlobalsRun = true;
		try {
		        main._process_globals();
		
        } catch (Exception e) {
			throw new RuntimeException(e);
		}
    }
}public static String  _process_globals() throws Exception{
 //BA.debugLineNum = 15;BA.debugLine="Sub Process_Globals";
 //BA.debugLineNum = 16;BA.debugLine="Dim Manager As BleManager";
_manager = new anywheresoftware.b4a.objects.BleManager();
 //BA.debugLineNum = 17;BA.debugLine="Dim readCharacteristic As BleCharacteristic";
_readcharacteristic = new anywheresoftware.b4a.objects.BleManager.GattCharacteristic();
 //BA.debugLineNum = 18;BA.debugLine="Dim writeCharacteristic As BleCharacteristic";
_writecharacteristic = new anywheresoftware.b4a.objects.BleManager.GattCharacteristic();
 //BA.debugLineNum = 19;BA.debugLine="Dim bleService As BleService";
_bleservice = new anywheresoftware.b4a.objects.BleManager.GattServiceWrapper();
 //BA.debugLineNum = 20;BA.debugLine="End Sub";
return "";
}
public static String  _tx_click() throws Exception{
String _txstring = "";
 //BA.debugLineNum = 114;BA.debugLine="Sub TX_Click";
 //BA.debugLineNum = 115;BA.debugLine="Dim TxString As String";
_txstring = "";
 //BA.debugLineNum = 116;BA.debugLine="TxString = \"TX Hello World !\" & CRLF	' 20 charact";
_txstring = "TX Hello World !"+anywheresoftware.b4a.keywords.Common.CRLF;
 //BA.debugLineNum = 117;BA.debugLine="If ConnectState = cstateConnect Then";
if (_connectstate==_cstateconnect) { 
 //BA.debugLineNum = 118;BA.debugLine="Log(\"Write -> \" & TxString)";
anywheresoftware.b4a.keywords.Common.Log("Write -> "+_txstring);
 //BA.debugLineNum = 119;BA.debugLine="writeCharacteristic.SetStringValue(TxString)";
_writecharacteristic.SetStringValue(_txstring);
 //BA.debugLineNum = 120;BA.debugLine="Manager.WriteCharacteristic(writeCharacteristic)";
_manager.WriteCharacteristic(_writecharacteristic);
 };
 //BA.debugLineNum = 122;BA.debugLine="End Sub";
return "";
}
}
