#include <SoftwareSerial.h>

SoftwareSerial mySerial(4, 5); // RX, TX

void setup()
{
  Serial.begin(9600);
  mySerial.begin(9600);
  delay(500);
  mySerial.write("AT+TYPE1");  // §61 -> param 1 : Auth not need PIN
  delay(50); 
  mySerial.write("AT+SHOW1");  // §57 -> param 1 : Show name
  delay(50);   
  mySerial.write("AT+RESET");  // §47 -> reset device
  delay(500); 
}

void loop() 
{
  if (mySerial.available())
    Serial.write(mySerial.read());
  if (Serial.available())
    mySerial.write(Serial.read());
}

